commit 5a2c4c1e171d2681a506f6de2235a32293e69b3f
Author: Patrick Palka <ppalka@redhat.com>
Date:   Thu Nov 18 16:05:13 2021

    c++: template-id ADL and partial instantiation [PR99911]
    
    Here when partially instantiating the call get<U>(T{}) with T=N::A
    (for which earlier unqualified name lookup for 'get' found nothing)
    the arguments after substitution are no longer dependent but the callee
    still is, so perform_koenig_lookup postpones ADL.  But then we go on to
    diagnose the unresolved template name anyway, as if ADL was already
    performed and failed.
    
    This patch fixes this by avoiding the error path in question when the
    template arguments of an unresolved template-id are still dependent,
    mirroring the dependence check in perform_koenig_lookup.
    
            PR c++/99911
    
    gcc/cp/ChangeLog:
    
            * pt.c (tsubst_copy_and_build) <case CALL_EXPR>: Don't diagnose
            name lookup failure if the arguments to an unresolved template
            name are still dependent.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp2a/fn-template24.C: New test.
    
    (cherry picked from commit 90de06a7b3ce6ae8381136e58a2dde91fbbb6eff)

diff --git a/gcc/cp/pt.c b/gcc/cp/pt.c
index d2b35da89a1..c1a60cae697 100644
--- a/gcc/cp/pt.c
+++ b/gcc/cp/pt.c
@@ -20312,7 +20312,9 @@ tsubst_copy_and_build (tree t,
 	if (function != NULL_TREE
 	    && (identifier_p (function)
 		|| (TREE_CODE (function) == TEMPLATE_ID_EXPR
-		    && identifier_p (TREE_OPERAND (function, 0))))
+		    && identifier_p (TREE_OPERAND (function, 0))
+		    && !any_dependent_template_arguments_p (TREE_OPERAND
+							    (function, 1))))
 	    && !any_type_dependent_arguments_p (call_args))
 	  {
 	    if (TREE_CODE (function) == TEMPLATE_ID_EXPR)
diff --git a/gcc/testsuite/g++.dg/cpp2a/fn-template24.C b/gcc/testsuite/g++.dg/cpp2a/fn-template24.C
new file mode 100644
index 00000000000..b444ac6a273
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/fn-template24.C
@@ -0,0 +1,16 @@
+// PR c++/99911
+// { dg-do compile { target c++20 } }
+
+namespace N {
+  struct A { };
+  template<class T> void get(A);
+};
+
+template<class T>
+auto f() {
+  return []<class U>(U) { get<U>(T{}); };
+}
+
+int main() {
+  f<N::A>()(0);
+}

